'------------------------------------------------
'   BoomSim by Tom Nally - Version 1 August 2002
'   steelweaver52@aol.com
'
'   Made with Liberty Basic
'   http://www.libertybasic.com
'
'   Made with Liberty Basic Workshope
'   http://iquizme.0catch.com/lb/
'
'   Released as Open Source
'
'   Can't remember from where I got the sound 
'   files.  Some place for free sound effects.
'   The launch sound was clipped from a much
'   larger wav file sounding thunder.
'------------------------------------------------

pi = 4*Atn(1)
True = 1 : False = 0

LoadBmp "FW01", "FW01.bmp"

'Place all the sprite names for all of the sparks
'in an array to allow them to be called with a
'loop, instead of individually.
Dim SparkID$(70)
For i = 1 to 70
    If (i < 10) Then
        SparkID$(i) = "Spark0" + Str$(i)
    End If
    If (i >= 10) Then
        SparkID$(i) = "Spark" + Str$(i)
    End If
Next i


'Populate the array which allows the user to
'choose the initial velocity of the projectile.
Dim V0(51)
Dim V0$(51)
For i = 1 to 51
    V0(i) = 119 + i
    V0$(i) = Str$(V0(i)) + " feet/sec"
Next i

V0index = 21
V0 = V0(V0index)

'Populate the array which allows the user
'to set the launch angle
Dim LaunchAngle(41)
Dim LaunchAngle$(41)
Dim LaunchAngleRads(41)

For i = 1 to 41
    LaunchAngle(i) = 69 + i
    LaunchAngle$(i) = Str$(69 + i) + " degrees"
    LaunchAngleRads(i) = (LaunchAngle(i)/360)*(2*pi)
Next i

LaunchAngleIndex = 21
LaunchAngle = LaunchAngle(LaunchAngleIndex)
LaunchAngleRads = LaunchAngleRads(LaunchAngleIndex)


'Establish gravitational acceleration
g = 32.2

'Populate the array which allows the user
'to choose the magnitude of the explosion
Dim ExploMag(10)
Dim ExploMag$(10)

ExploMag$(1) = "Greatest"
ExploMag$(10) = "Least"
For i = 2 to 9
    ExploMag$(i) = Str$(11-i)
Next i

For i = 1 to 10
    ExploMag(i) = 1.05 - 0.05*i
Next i

ExploMagIndex = 3
ExploMag = ExploMag(ExploMagIndex)

'*******  BigBall Properties  *******

x0 = 280         'Initial location of the BigBall in the x-direction
y0 = 10          'Initial location of the BigBall in the y-direction
                 'Note: Initial speed of the BigBall at launch time is V0

Vx0 = V0 * Cos(LaunchAngleRads)     'BigBall initial velocity component in the x-direction
Vy0 = V0 * Sin(LaunchAngleRads)     'BigBall initial velocity component in the y-direction

Dim BBx(600)      'Location of BigBall along it's trajectory
Dim BBy(600)      'Location of BigBall along it's trajectory

'**** Spark Properties *****
SparkVmax = 80
Dim VSpark(70)
Dim VSparkx(70)
Dim VSparky(70)
Dim SparkAngle(70)
Dim Sparkx(70,200)
Dim Sparky(70,200)

Dim FWPattern(3)
Dim FWPattern$(3)
FWPattern$(1) = "Circular"
FWPattern$(2) = "BowTie"
FWPattern$(3) = "Upward Chute"

FWPattern(1) = 1
FWPattern(2) = 2
FWPattern(3) = 3

FWPatternIndex = 1
FWPattern = FWPattern(FWPatternIndex)

'Initially, sounds are OFF, but the user
'can switch them ON
PlaySounds = 0


[InitColors]
    ForegroundColor$ = "Black"
    BackgroundColor$ = "Buttonface"
    TexteditorColor$ = "White"
    TextboxColor$    = "White"
    ComboboxColor$   = "White"
    ListboxColor$    = "White"

[WindowSetup]
    NoMainWin
    WindowWidth = 800 : WindowHeight = 600
    UpperLeftX = Int((DisplayWidth-WindowWidth)/2)
    UpperLeftY = Int((DisplayHeight-WindowHeight)/2)

[ControlSetup]

Menu        #LBFW, "&File" , "E&xit", [quit]
Graphicbox  #LBFW.Gbox1, 210, 5, 560, 500
Statictext  #LBFW.statictext2, "Set Launch Speed:", 15, 145, 135, 20
Statictext  #LBFW.statictext3, "Status:", 15, 520, 50, 20
Statictext  #LBFW.statictext4, "Set Launch Angle:", 15, 205, 110, 20
Statictext  #LBFW.statictext5, "Set Explosion Magnitude:", 15, 265, 155, 20
Statictext  #LBFW.statictext6, "Set Fireworks Pattern:", 15, 325, 155, 20
Button      #LBFW.About, "About BoomSim...",[About.click],UL, 555, 515, 145, 25
Button      #LBFW.Quit, "Quit",[Quit.click],UL, 710, 515, 60, 25
Button      #LBFW.Launch, "Launch!",[Launch.click],UL, 10, 445, 145, 50
BmpButton   #LBFW.bmpbutton2, "fwsplash.bmp",[About.click],UL, 10, 5
Textbox     #LBFW.FWStatus, 85, 515, 450, 25
Combobox    #LBFW.cboV0,V0$(,[cboV0.click], 10, 165, 142, 150
Combobox    #LBFW.cboLaunchAngle,LaunchAngle$(,[cboLaunchAngle.click], 10, 225, 142, 150
Combobox    #LBFW.cboExplMag,ExploMag$(,[cboExplMag.click], 10, 285, 142, 150
Combobox    #LBFW.cboExPattern,FWPattern$(,[ExPattern.click], 10, 345, 142, 150
Checkbox    #LBFW.EnableSounds, "Enable Sounds",[EnableSounds.click],[DisableSounds.click], 10, 390, 135, 25


Open "BoomSim - The Fireworks Simulator" For Window As #LBFW

    Print #LBFW, "trapclose [Quit.click]"
    Print #LBFW.Gbox1, "down; fill Black; flush"
    Print #LBFW.Gbox1, "setfocus; when mouseMove [MouseChange1]"
    Print #LBFW, "font arial 10"
    Print #LBFW.Gbox1, "getbmp NightSky 0 0 560 500"
    Print #LBFW.Gbox1, "background NightSky";

    GoSub [Define.All.Sprites]
    GoSub [Initialize.Controls]

[loop]
    Wait

[quit]
    Close #LBFW : End

[MouseChange1]
    'MouseX and MouseY contain mouse coordinates
    GoTo [loop]

[Quit.click]
    'place code here
    GoSub [Unload.All.Bitmaps]
    Close #LBFW : End


[Initialize.Controls]

    Print #LBFW.cboV0, "selectindex "; V0index
    Print #LBFW.cboLaunchAngle, "selectindex "; LaunchAngleIndex
    Print #LBFW.cboExplMag,  "selectindex "; ExploMagIndex
    Print #LBFW.cboExPattern,  "selectindex "; FWPatternIndex
    Print #LBFW.EnableSounds, "reset"
    PlaySounds = 0

    Return



[Launch.click]
    'place code here

    GoSub [Test.Sprite.Drawing]
    GoTo [loop]

[bmpbutton2.click]
    'place code here
    GoTo [loop]

[cboV0.click]
    Print #LBFW.cboV0, "selectionindex? V0index"
    V0 = V0(V0index)
    Vx0 = V0 * Cos(LaunchAngleRads)
    Vy0 = V0 * Sin(LaunchAngleRads)

    Print #LBFW.FWStatus, "Initial Velocity = "; V0; " feet/sec"
    GoTo [loop]

[cboLaunchAngle.click]
    Print #LBFW.cboLaunchAngle, "selectionindex? LaunchAngleIndex"
    LaunchAngle = LaunchAngle(LaunchAngleIndex)
    LaunchAngleRads = LaunchAngleRads(LaunchAngleIndex)
    LArads = LaunchAngleRads - LVArad + 2*LVArad*Rnd(1) ' True launch angle, including the random variation
    Vx0 = V0 * Cos(LaunchAngleRads)
    Vy0 = V0 * Sin(LaunchAngleRads)
    Print #LBFW.FWStatus, "Launch Angle = "; LaunchAngle; " degrees or "; LaunchAngleRads; " radians"
    GoTo [loop]

[cboExplMag.click]
    Print #LBFW.cboExplMag, "selectionindex? ExploMagIndex"
    ExploMag = ExploMag(ExploMagIndex)
    Print #LBFW.FWStatus, "Explosion Magnitude = "; ExploMag
    GoTo [loop]

[ExPattern.click]
    Print #LBFW.cboExPattern, "selectionindex? FWPatternIndex"
    FWPattern = FWPattern(FWPatternIndex)
    Print #LBFW.FWStatus, "Explosion Pattern = "; FWPattern
    GoTo [loop]

[EnableSounds.click]
    PlaySounds = 1

    GoTo [loop]

[DisableSounds.click]
    PlaySounds = 0

    GoTo [loop]


[Define.All.Sprites]

    'Print the graphic image to the screen
    'from which all sprites will be defined
    Print #LBFW.FWStatus, "Creating sprite definitions"
    Print #LBFW.Gbox1, "drawbmp FW01 0 0"

    'Get sparks 1 through 35
    For i = 1 to 35
        Print #LBFW.Gbox1, "getbmp "; SparkID$(i); " "; (1+3*i); " 0 3 6"
        Print #LBFW.Gbox1, "addsprite "; SparkID$(i); " "; SparkID$(i)
    Next i

    'Get sparks 36 through 70
    For i = 36 to 70
        Print #LBFW.Gbox1, "getbmp "; SparkID$(i); " "; (1+3*(i-35)); " 7 3 6"
        Print #LBFW.Gbox1, "addsprite "; SparkID$(i); " "; SparkID$(i)
    Next i

'--------------------------------------------------

    'Get the Big Ball sprite from the graphic image
    Print #LBFW.Gbox1, "getbmp BigBall 114 0 5 10"
    Print #LBFW.Gbox1, "addsprite BigBall BigBall"

    'Cover up the bitmap that was used to
    'get the sprite images
    Print #LBFW.Gbox1, "backcolor black"
    Print #LBFW.Gbox1, "place 0 0"
    Print #LBFW.Gbox1, "boxfilled 220 70"

    'Place all Sprites below the radar
    For i = 1 to 70
        Print #LBFW.Gbox1, "spritexy "; SparkID$(i); " "; 280; " "; 1000
    Next i
    Print #LBFW.Gbox1, "spritexy BigBall "; 280;" "; 1000

    Return


[Test.Sprite.Drawing]

    Print #LBFW.FWStatus, "Calculating spark positions..."

    'Step (1)
    '-------
    'Position x0, the launching point of the big ball
    'such that the top of the parabolic arc occurs
    'in the middle of the screen.  To do this, calculate the constants
    'aa and bb first.
    aa = -1*g/(2*Vx0^2)
    bb = (Vy0/Vx0) + 2*g*0/(2*Vx0^2) 'For my purposes, the second part of
    Xoffset = -1*bb/(2*aa)           'this equation will always be zero
    x0 = 280 - Xoffset

    'Step (2)
    '-------
    'Calculate tTop, which is the time it takes for
    'the "Big Ball" to get to the top of its parabolic
    'arc.  To do this, bb must be recalculated using the 
    'new value For x0.  However, if the launch angle is
    '90 degrees (straight up, LaunchAngleIndex = 21), 
    'an alternate formula for tTop must be used.
    'Note that xTop is also calculated.  xTop is the
    'x-location of the big ball when the the big ball
    'gets to the top of its parabolic arc.
    If (LaunchAngleIndex <> 21) Then
        bb = (Vy0/Vx0) + 2*g*x0/(2*Vx0^2)
        xTop = -1*bb/(2*aa)
        tTop = (xTop - x0)/Vx0
    End If
    '...however...
    If (LaunchAngleIndex = 21) Then
        tTop = Vy0/g
        xTop = x0
    End If

    'Step (3)
    '-------
    'Calculate yTop, which is the y-location of the big ball
    'when it has reached the top of it's parabolic arc.
    'If (LaunchAngleIndex <> 21) Then
    '    yTop = y0 + (Vy0/Vx0)*(xTop - x0) - (g/(2*Vx0^2))*(xTop - x0)^2
    'End If
    '...however...
    'If (LaunchAngleIndex = 21) Then
    '    yTop = y0 + Vy0*tTop - (1/2)*g*tTop^2
    'End If

    yTop = y0 + Vy0*tTop - (1/2)*g*tTop^2

    'Step (4)
    '-------
    'Calculate the path of the Big Ball, from the moment it
    'is launched until the moment it reaches the top of it's
    'parabolic arc.  Store these values in the two arrays
    'BBx(i) and BBy(i).
    i = 1
    LastBBi = 1
    For tt = 0 to tTop step 0.1
        BBx(i) = x0 + Vx0*tt
        BBy(i) = y0 + Vy0*tt - (1/2) * g * tt^2
        LastBBi = i
        i = i + 1
    Next tt


    'Step (5)
    '-------
    'Develop initial spark velocities and angles
    'For all 70 sparks.  Notice that the angles are
    'total random, somewhere between 0 and 2*pi.
    'The velocities are somewhat random, too.  They
    'vary between 90% and 110% of SparkVmax, then are
    'multiplied by ExploMag, which is under user control.
    If (FWPattern = 1) Then
        For i = 1 to 70
           VSpark(i) = SparkVmax*(0.90 + 0.2*Rnd(1))*ExploMag
           SparkAngle(i) = 2*pi*Rnd(1)
           VSparkx(i) = VSpark(i)*Cos(SparkAngle(i)) + Vx0
           VSparky(i) = VSpark(i)*Sin(SparkAngle(i))
        Next i
    End If

    If (FWPattern = 2) Then
        For i = 1 to 35
            VSpark(i) = SparkVmax*(0.90 + 0.2*Rnd(1))*ExploMag
            SparkAngle(i) = 2.618 + (1.047*Rnd(1))
            VSparkx(i) = VSpark(i)*Cos(SparkAngle(i)) + Vx0
            VSparky(i) = VSpark(i)*Sin(SparkAngle(i))
        Next i
        For i = 36 to 70
           VSpark(i) = SparkVmax*(0.90 + 0.2*Rnd(1))*ExploMag
           SparkAngle(i) = 5.760 + (1.047*Rnd(1))
           VSparkx(i) = VSpark(i)*Cos(SparkAngle(i)) + Vx0
           VSparky(i) = VSpark(i)*Sin(SparkAngle(i))
        Next i
    End If

    If (FWPattern = 3) Then
        For i = 1 to 70
           VSpark(i) = SparkVmax*(0.90 + 0.2*Rnd(1))*ExploMag
           SparkAngle(i) = 1.047 + (1.047*Rnd(1))
           VSparkx(i) = VSpark(i)*Cos(SparkAngle(i)) + Vx0
           VSparky(i) = VSpark(i)*Sin(SparkAngle(i))
        Next i
    End If


    'Step (6)
    '-------
    'Calculate the x- and y-coordinates of all 70 sparks 
    'from the time of the explosion.
    For i = 1 to 70
        For j = 1 to 90
            tt = j/10
            Sparkx(i,j) = xTop + VSparkx(i)*tt
            Sparky(i,j) = yTop + VSparky(i)*tt - (1/2)*g*tt^2
        Next j
    Next i

    'Note: at this point, the x- and y-coordinates of
    'the big ball, as well as the coordinates of all
    '70 sparks have been calculated.  Now we can
    'go about drawing the appropriate sprites
    'at these coordinates.

    Print #LBFW.FWStatus, "Showing firworks explosion..."

    'Step (7)
    '-------
    'Display the path of the Big Ball using the BBx(i) and BBy(i)
    'coordinates calculated earlier
    If (PlaySounds = 1) Then
        PlayWave "Launch02.wav", async
    End If
    For i = 1 to LastBBi
        Print #LBFW.Gbox1, "spritexy BigBall "; BBx(i);" "; (500-BBy(i))
        Print #LBFW.Gbox1, "drawsprites"
    Next i

    'Step (7a)
    '-------
    'Now that the Big Ball has exploded, place it beyond
    'view of the screen
    Print #LBFW.Gbox1, "spritexy BigBall "; 280;" "; 1000
    Print #LBFW.Gbox1, "drawsprites"


    'Step (8)
    '-------
    'Display all 70 sparks (each one is a sprite)
    'one frame at a time.
    If (PlaySounds = 1) Then
        PlayWave "implosion2.wav", async
    End If
    For j = 1 to 90
        For i = 1 to 70
        Print #LBFW.Gbox1, "spritexy "; SparkID$(i); " "; Sparkx(i,j); " "; (500-Sparky(i,j))
        Next i
        Print #LBFW.Gbox1, "drawsprites"
    Next j

    Print #LBFW.FWStatus, "Simulation complete"


    Return


[Unload.All.Bitmaps]

    UnloadBmp "NightSky"

    For i = 1 to 70
        UnloadBmp SparkID$(i)
    Next i

    UnloadBmp "BigBall"

    Return


[About.click]

    ForegroundColor$ = "Black"
    BackgroundColor$ = "Buttonface"
    TexteditorColor$ = "White"
    TextboxColor$    = "White"
    ComboboxColor$   = "White"
    ListboxColor$    = "White"

    NoMainWin
    WindowWidth = 500 : WindowHeight = 245
    UpperLeftX = Int((DisplayWidth-WindowWidth)/2)
    UpperLeftY = Int((DisplayHeight-WindowHeight)/2)


Statictext  #About.static1, "It ain't rocket science.  No, really.", 50, 10, 170, 20
Statictext  #About.static2, "http://iquizme.0catch.com/lb/", 310, 135, 155, 20
Statictext  #About.static3, "Made with Liberty Basic", 320, 65, 120, 20
Statictext  #About.static4, "http://www.libertybasic.com", 310, 85, 150, 20
Statictext  #About.static5, "By Tom Nally    August 2002", 305, 15, 155, 20
Statictext  #About.static6, "Released as open source", 315, 35, 130, 20
Statictext  #About.static7, "Made with Liberty Basic Workshop", 295, 115, 175, 20
Button      #About.AboutClose, "Close",[AboutClose.click],UL, 325, 175, 105, 25
BmpButton   #About.bmpbutton1, "splash2.bmp",[Splash2.click],UL, 10, 40

Open "About BoomSim" For Dialog_modal As #About

    Print #About, "trapclose [AboutClose.click]"
    Print #About, "font arial 8"

[About.loop]
    Wait

[AboutClose.click]
    'place code here
    Close #About
    GoTo [loop]

[Splash2.click]
    'place code here
    GoTo [About.loop]









'----------------------
'Define all functions
'----------------------

Function Degs2Rads(Degs)
  
  Degs2Rads = 0.017453 * Degs
End Function

